import { ConfigKind } from './config';
export interface IServer {
    id?: string;
    ip: string;
    name: string;
    description?: string;
    type: string;
    status: string;
}
export interface IMage {
    repository?: string;
    tag?: string;
    pullPolicy?: string;
}
export interface IServerConfig {
    kind: ConfigKind.SERVER;
    workspaceId: string;
}
export interface IServerOptions {
    container?: IUserContainer;
    templateName?: string;
    services?: IUserContainerService[];
    appData?: IGlobalConfig;
}
export interface IGlobalConfig {
    name?: string;
    logLevel?: string;
    fileRootPath?: string;
    replicaCount?: number;
}
export interface IResourceLimit {
    requests?: {
        cpu?: string;
        memory?: string;
    };
    limits?: {
        cpu?: string;
        memory?: string;
    };
}
export interface IUserContainer {
    name?: string;
    image?: IMage;
    properties?: IContainerProperties;
    env?: {
        [key: string]: string;
    };
    resourceLimit?: IResourceLimit;
}
export interface IUserContainerService {
    name?: string;
    internalPort?: number;
    externalPort?: number;
}
export interface IContainerProperties {
    name?: string;
    repoUrl?: string;
    repoBranch?: string;
    internalPort?: number;
    [key: string]: string | number;
}
export interface IServerPayload {
    kind: ConfigKind.SERVER;
    deploymentId?: string;
    provider: string;
}
